#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    while (q--) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        int kor = 0;
        int trn = 0;

        for (int i = l; i <= r; i++) {
            if ((kor & a[i]) == 0) {
                kor |= a[i];
                trn++;
            }
        }

        cout << trn << '\n';
    }

    return 0;
}